require 'eventmachine'
require 'http/parser'
require 'uri'
require 'json'

module NginxController
  module Docker
    class Listener < EM::Connection
      include EventMachine::Deferrable
      attr_accessor :cb

      def self.run(&block)
        EventMachine.connect_unix_domain('/var/run/docker.sock', self) do | l |
          l.cb = block
        end
      end

      def initialize
        @parser = Http::Parser.new

        @parser.on_body = proc do |chunk|
          ev = JSON.parse(chunk)
          self.cb.call(ev) if self.cb
        end

        @parser.on_message_complete = proc do |env|

        end
      end

      def connection_completed
        uri = "/v1.39/events?filters={\"type\":{\"service\":true}}"
        req = []
        req << "GET #{URI.encode(uri)} HTTP/1.1"
        req << "Host: docker"
        req << "Accept: */*"
        req << "User-Agent: nginx controller"
        req << ""
        req << ""
        send_data req.join("\r\n")
      end

      def receive_data(response)
        @parser << response
      end
    end
  end
end